<template>
  <ion-page>
    <page-top-bar
      :needBackButton="true"
      :title="`${t(
        'creation_post.header',
        {},
        { locale: $store.state.appLang }
      )}`"
    />
    <ion-content>
      <div class="mt-5">
        <div>
          <ion-text class="flex justify-center text-left mb-3">
            {{
              t(
                "creation_post.related_goal",
                {},
                { locale: $store.state.appLang }
              )
            }}
          </ion-text>
        </div>
        <ion-searchbar
          v-on:keyup="searchGoals($event.target.value)"
          @ionClear="goals = []"
          :placeholder="`${t(
            'search_page.search_placeholder',
            {},
            { locale: $store.state.appLang }
          )}`"
          v-model="goalTitle"
          search-icon="search-outline"
          type="search"
          class="searchbar-input"
        />
        <div>
          <ion-list class="small-list">
            <ion-item
              class="text-center clickable-cursor"
              v-for="goal in goals"
              :key="goal"
              @click="selectGoal(goal)"
            >
              <div
                class="
                  w-full
                  h-full
                  flex flex-row
                  items-center
                  pl-2
                  text-center
                "
              >
                <span class="flex-auto flex-col text-left text-ellipsis">
                  {{ goal.title }}
                </span>
                <ion-icon
                  v-if="goal.id == selectedGoal"
                  color="success"
                  :icon="checkmarkCircleOutline"
                  class="h-6 w-6 mr-2 flex flex-shrink-0"
                />
              </div>
            </ion-item>
          </ion-list>
        </div>
      </div>
      <div v-if="selectedGoal" class="m-5 h-10 pl-2 border flex items-center">
        <span
          class="flex-auto flex-col text-left font-bold text-sm text-ellipsis"
        >
          {{ selectedGoal.title }}
        </span>
        <ion-icon
          :color="goalStatus[selectedGoal.status].color"
          :icon="goalStatus[selectedGoal.status].icon"
          class="h-6 w-6 mr-2 flex flex-shrink-0"
        />
      </div>
      <div v-else>
        <ion-text class="flex justify-center m-8">
          {{
            t(
              "creation_post.no_goal_selected",
              {},
              { locale: $store.state.appLang }
            )
          }}
        </ion-text>
      </div>
      <div>
        <div>
          <ion-text class="flex justify-center text-left mb-3">
            {{
              t(
                "creation_post.type_description",
                {},
                { locale: $store.state.appLang }
              )
            }}
          </ion-text>
        </div>
        <div class="flex relative justify-center text-left">
          <ion-textarea
            maxlength="255"
            :auto-grow="true"
            :placeholder="`${t(
              'creation_post.description_placeholder',
              {},
              { locale: $store.state.appLang }
            )}`"
            class="no-padding-input text-left border m-2 min-h-full"
            v-model="description"
          />
          <ion-text
            color="medium"
            v-if="description"
            class="absolute bottom-0 right-0 pr-8 pb-3 text-xs"
          >
            {{ 255 - description.length }}
          </ion-text>
        </div>
        <div class="flex justify-center text-left mt-10">
          <ion-button
            :disabled="!(description && selectedGoal)"
            @click="createPost"
            class="flex"
          >
            {{
              t("creation_post.create", {}, { locale: $store.state.appLang })
            }}
          </ion-button>
        </div>
      </div>
    </ion-content>
  </ion-page>
</template>

<script>
import { defineComponent, ref, reactive } from "vue";
import {
  IonTextarea,
  IonText,
  IonButton,
  IonContent,
  IonPage,
  IonList,
  IonItem,
  IonSearchbar,
  IonIcon,
} from "@ionic/vue";
import { useI18n } from "vue-i18n";
import PageTopBar from "../components/PageTopBar.vue";
import goalsService from "../services/goals";
import toastService from "../services/toast";
import postsService from "../services/posts";
import {
  searchOutline,
  checkmarkCircleOutline,
  ellipsisHorizontalCircleOutline,
  hourglassOutline,
} from "ionicons/icons";

export default defineComponent({
  components: {
    PageTopBar,
    IonTextarea,
    IonButton,
    IonContent,
    IonPage,
    IonText,
    IonList,
    IonItem,
    IonSearchbar,
    IonIcon,
  },
  setup() {
    const { t, locale } = useI18n();
    const description = ref("");
    const goalTitle = ref("");
    const selectedGoal = ref(null);
    const goals = ref([]);
    const goalStatus = reactive({
      DONE: {
        color: "success",
        icon: checkmarkCircleOutline,
      },
      ONGOING: {
        color: "primary",
        icon: ellipsisHorizontalCircleOutline,
      },
      TODO: {
        color: "danger",
        icon: hourglassOutline,
      },
    });
    return {
      t,
      locale,
      selectedGoal,
      goals,
      description,
      goalTitle,
      searchOutline,
      goalStatus,
      ellipsisHorizontalCircleOutline,
      checkmarkCircleOutline,
      hourglassOutline,
    };
  },
  methods: {
    async createPost() {
      const newPost = {
        goal_id: this.selectedGoal.id,
        description: this.description,
      };
      try {
        const response = await postsService.create(newPost);
        if (response.status === 200) {
          this.goalTitle = "";
          this.description = "";
          this.$router.back();
        } else {
          await this.openErrorToast();
        }
      } catch {
        await this.openErrorToast();
      }
    },
    async openErrorToast() {
      await toastService.openErrorToast(
        this.t("toaster_error", {}, { locale: this.$store.state.appLang })
      );
    },
    selectGoal(goal) {
      this.selectedGoal = goal;
    },
    async searchGoals(goalTitle) {
      if (goalTitle.length > 0) {
        try {
          const response = await goalsService.search(goalTitle);
          if (response.status === 200) {
            this.goals = response.data;
          } else {
            await this.openErrorToast();
          }
        } catch (error) {
          await this.openErrorToast();
        }
      } else {
        this.goals = [];
      }
    },
    async setSelectedGoal(selectedGoalId) {
      if (selectedGoalId) {
        try {
          const response = await goalsService.get(parseInt(selectedGoalId));
          if (response.status === 200) {
            this.selectedGoal = response.data;
          } else {
            await this.openErrorToast();
          }
        } catch (error) {
          await this.openErrorToast();
        }
      }
    },
  },
  async mounted() {
    await this.setSelectedGoal(this.$route.query.goal);
  },
});
</script>

<style scoped>
.small-list {
  height: 9rem;
}

.border {
  border: solid 2px var(--ion-color-primary);
  border-radius: 10px;
}

ion-textarea {
  --padding-end: 5px;
  --padding-start: 5px;
  margin-right: 20px;
  margin-left: 20px;
}
</style>
